<!DOCTYPE html>
<html lang="ja">
<body>

<?php
// 記事一覧を取得するAPIのエンドポイント
$api_endpoint = 'https://サイトURL/wp-json/wp/v2/posts';

// 取得する情報のリスト
$field_names = ['ID', 'permalink', 'title', 'category', 'published_date', 'updated_date'];

// 出力ファイル名
$now = date('YmdHis');
$filename = "{$now}.csv";

// 出力ファイルを開く
$file = fopen($filename, 'w');
fputcsv($file, $field_names);

// ページネーションを使ってすべての記事を取得
$page = 1;
$count = 0;
while (true) {
    $params = [
        'per_page' => 100,
        'page' => $page,
    ];
    $url = $api_endpoint . '?' . http_build_query($params);
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($ch);
    $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    if ($http_code !== 200) {
        echo "Error: status code {$http_code}\n";
        break;
    }

    $posts = json_decode($response, true);
    if (empty($posts)) {
        break;
    }
    // 各記事の情報をCSVに書き込む
    foreach ($posts as $post) {
        $row = [
            $post['id'],
            $post['link'],
            $post['title']['rendered'],
            implode(',', array_map(function($category) { return $category['name']; }, $post['categories'])),
            $post['date'],
            $post['modified'],
        ];
        fputcsv($file, $row);
        $count++;
        // カウントアップを表示
        echo "{$count} posts processed";
        echo "<br>";
    }
    $page++;
}
// FileClose
fclose($file);

// 処理終了を表示
echo "完了\n";
?>

</body>
</html>